import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.webrenderer.*;

public class MainFrame extends JFrame implements ActionListener
{
	static IBrowserCanvas browser;
	protected JButton back, forward, histButton, print, printprev, silentprint;
	protected JTextField address;
	protected HistoryPanel histPan;

	public MainFrame()
	{
		super();
		
		//These functions can be used to set the wr.cfg and webrenderer.dll, mozctlplugin.dll        
        //BrowserFactory.setCFGPath("lib");
        //BrowserFactory.setDllPath("lib");

		//Spawning the browser instance (Can either be Mozilla, InternetExplorer or Safari)
		browser = BrowserFactory.spawnMozilla();
		
		//Setting the proxy server
		//browser.setProxyProtocol( new ProxySetting( ProxySetting.PROTOCOL_ALL, "my.proxy.server.com", 8080));
		//browser.enableProxy();

		//loading the URL - must be called after browser is spawned
		browser.loadURL("http://www.chicousd.org/__dept/schools/index.html");
		
		//Creating the document History button
		histButton = new JButton("History");
		histButton.addActionListener(this);
		histButton.setPreferredSize(new Dimension(115, 18));
		
		//Creating the address (url) textfield
		address = new JTextField();
		address.setText("http://developer.webrenderer.com");
		address.addActionListener(this);
		
		//Creating a browser back button
		back = new JButton("<<");
		back.setPreferredSize(new Dimension(60,18));
		back.addActionListener(this);

		//Creating a browser foward button
		forward = new JButton(">>");
		forward.setPreferredSize(new Dimension(60,18));
		forward.addActionListener(this);
		
		//Creating a print and silent print button
		print = new JButton("Print");
		print.setPreferredSize(new Dimension(80, 18));
		printprev = new JButton("Preview");
		printprev.setPreferredSize(new Dimension(80, 18));
		silentprint = new JButton("SPrint");
		silentprint.setPreferredSize(new Dimension(80,18));
		
		//Adding the buttons to a toolbar
		JPanel toolbar = new JPanel();
		toolbar.setLayout(new FlowLayout(FlowLayout.LEFT));
		toolbar.add(back);
		toolbar.add(forward);
		toolbar.add(histButton);
		toolbar.add(print);
		toolbar.add(silentprint);
		toolbar.add(printprev);
		
		JPanel top = new JPanel();
		top.setLayout(new GridLayout(2, 1));
		top.setPreferredSize(new Dimension(10, 50));
		top.add(toolbar);
		top.add(address);
		
		histPan = new HistoryPanel(browser.getHistory());
		
		getContentPane().setLayout(new BorderLayout(4, 4));
	
		//Adding the browser to a JFrame
		getContentPane().add((Canvas)browser, BorderLayout.CENTER);
		getContentPane().add(top, BorderLayout.NORTH);
		getContentPane().add(histPan, BorderLayout.WEST);
		
		setTitle("WebRenderer Test Browser");		
		setSize(640, 480);
		show();

		/******
		//Print listener to capture Print dialog return value
		******/
		
		browser.addPrintListener(new com.webrenderer.event.PrintListener(){
		   public void onStatusChange(com.webrenderer.event.PrintEvent e){
		           System.out.println("Print Status: "+e.getStatus());
		   }
		});
		
		//Array to store list of available printers
		String printers[] = browser.getPrinterNames();

		//Command line output of printers list
         for(int i = 0; i < printers.length; i++){
                 System.out.println("Available printer:"+printers[i]);
         }
         
         //Adding action listener to listen for button presses and then silently print
         silentprint.addActionListener(new ActionListener(){
                 public void actionPerformed(ActionEvent e){
                         browser.print(2);       // 2 is the Silent print function
                 }
         });
         //Adding action listener to listen for the button presses and show printPreview
         printprev.addActionListener(new ActionListener(){
                 public void actionPerformed(ActionEvent e){
                         browser.printPreview();
                 }
         });
         //Adding action listener to listen for the button presses and do a normal print
         print.addActionListener(new ActionListener(){
                 public void actionPerformed(ActionEvent e){
                         browser.print(1);
                 }
         });
		

	}
	
	public void actionPerformed(ActionEvent e)
	{
		//Action events from the Location textfield and buttons
		if (e.getSource() == address)
		{
			browser.loadURL(address.getText());
		}
		
		if (e.getSource() == back)
		{
			browser.goBack();
		}
		
		if (e.getSource() == forward)
		{
			browser.goForward();
		}
		
		if (e.getSource() == histButton )
		{
			histPan.display(!histPan.isDisplayed());
		}
		
		histPan.update();
		repaint();
	}
	public static void main(String[] args){
		new MainFrame();
	}
}